Unit ZF19R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure ZF19R(F :Func_F1; A :Real; B :Real; N :Integer;
                var A1 :Array of Real; var B1 :Array of Real;
                NB :Integer; var NROOT :Integer);

implementation

procedure ZF19R(F :Func_F1; A :Real; B :Real; N :Integer;
                var A1 :Array of Real; var B1 :Array of Real;
                NB :Integer; var NROOT :Integer);
var
I :Integer;
FP,FC,X,DX :Real;
const
ZERO :Real = 0.0;
label
_10,_20,_30;
begin
NROOT := 0;
X := A;
DX := (B-A)/N;
FP := F(X);
for I:=1 to N do
 begin
  X := X+DX;
  FC := F(X);
  if ( FC*FP >= ZERO ) 
   then goto _10;
  NROOT := NROOT+1;
  A1[NROOT-1] := X-DX;
  B1[NROOT-1] := X;
_10:
  FP := FC;
  if ( NROOT = NB ) 
   then goto _30;
_20:
 end;
_30:
end;

end.
